var exphbs = require('express-handlebars');
module.exports = function(include, puremvc) {
	/**
	 * @class npmvc.view.route.IndexRoute
	 * @extends puremvc.Proxy
	 *
	 */
	puremvc.define(
		// CLASS INFO
		{
			name: "npmvc.view.middleware.Handlebars",
			parent: npmvc.view.middleware.Middleware
		}, {
			onRegister: function() {
				this.expressMediator = this.facade.retrieveMediator(npmvc.view.mediator.ExpressMediator.NAME);
			},
			init: function(config) {
				if (config.cache == true) this.getViewComponent().enable('view cache');
				this.expressMediator.getViewComponent().engine('.html', exphbs({
					helpers: (config.helpers || {}),
					extname: ".html",
					layoutsDir: config.template_folder + "handlebars/layout",
					defaultLayout: "layout.html",
					partialsDir: config.template_folder + "handlebars/partials"
				}));
				this.expressMediator.getViewComponent().set('views', config.template_folder + "handlebars/")
				this.expressMediator.getViewComponent().set('view engine', '.html');
			}
		},
		// STATIC MEMBERS	
		{
			NAME: "npmvc.view.middleware.Handlebars"
		});
}